from abc import abstractmethod



class Owner(object):
    @property
    @abstractmethod
    def REPOSITORY_TYPE(self):
        raise NotImplementedError("Please Implement this method")

    @abstractmethod
    def get_repos(self):
        raise NotImplementedError("Please Implement this method")

    @staticmethod
    @abstractmethod
    def build_from_config():
        raise NotImplementedError("Please Implement this method")

    @staticmethod
    def builder(repo_type):
        from git_cloner.model.owner.github_owner import GithubOwner
        from git_cloner.model.owner.gitlab_owner import GitlabOwner
        from git_cloner.model.repository import Repository

        if repo_type == Repository.GITHUB: return GithubOwner.build_from_config()
        if repo_type == Repository.GITLAB: return GitlabOwner.build_from_config()
        raise RuntimeError("Invalid repository type")
