class Remote(object):
    REMOTE_ADD_TEMPLATE = "git remote add {uuid} {url}"
    REMOTE_DELETE_TEMPLATE = "git remote remove {uuid}"

    CLONE_TEMPLATE = "git clone {url} {{path}}"

    def get_name(self):
        raise NotImplementedError("Please Implement this method")

    def get_owner(self):
        raise NotImplementedError("Please Implement this method")

    def build_remote_url(self):
        raise NotImplementedError("Please Implement this method")

    def build_remote_delete(self):
        return self.REMOTE_DELETE_TEMPLATE.format(uuid=self.get_name())

    def build_remote_add(self):
        return self.REMOTE_ADD_TEMPLATE.format(
            uuid=self.get_name(),
            url=self.build_remote_url()
        )

    def build_clone_cmd(self):
        return self.CLONE_TEMPLATE.format(url=self.build_remote_url())
