import json

from git_cloner.model.owner.owner import Owner
from git_cloner.model.repository import RawRepository, Repository
from git_cloner.utils import logger
from git_cloner.utils.config import Config


def mass_cloner():
    out = Config.get_config().dir_out
    repos = get_repos()
    results = [repo.clone(out) for repo in repos]
    return [result for result in results if result is not None]


def get_repos():
    if Config.get_config().retry is None:
        owner = Owner.builder(Config.get_config().type)
        return owner.get_repos()
    return log_retry_path(Config.get_config().retry)


def log_retry_path(path):
    with open(path) as file:
        lines = [line.strip() for line in file.readlines()]
        filtered = [line for line in lines if line.endswith("False")]
        return [RawRepository(logger.build_remote_from_log_line(line)) for line in filtered]

