import os
import requests

from git_cloner.utils.config import Config


def read(fname):
    with open(os.path.join(os.path.dirname(__file__), fname)) as f:
        return f.read().strip()


def make_request(url, headers=None, auth_if_possible=True):
    if headers is None:
        headers = {}
    config = Config.get_config()
    auth = (config.user, config.password) if config.user and auth_if_possible else None
    if config.token is not None:
        headers['PRIVATE-TOKEN'] = config.token
    result = requests.get(url, auth=auth, headers=headers)
    if result.status_code != 200:
        raise RuntimeError("Incorrect request {}\n{}".format(url, str(result.content)))

    return result.json()
