import os
from setuptools import setup


def setup_read(fname):
    return open(os.path.join(os.path.dirname(__file__), fname)).read().strip()


required = [
    'docopt==0.6.2',
    'requests==2.18.4'
]
os.path.join(os.getcwd(),'VERSION')
setup(name='git_cloner',
      version=setup_read('VERSION'),
      author="Francisco Huertas",
      author_email="francisco@fhuertas.com",
      license="Apache2",
      packages=["git_cloner"],
      description="Python tool for clon repositories",
      long_description=setup_read('README.md'),
      url='https://github.com/fhuertas/python_base',
      download_url="https://github.com/fhuertas/python_base/tarball/{}".format(setup_read('VERSION')),
      install_requires=required,
      classifiers=[
          "Development Status :: 5 - Production/Stable",
          "Topic :: Utilities",
          "License :: OSI Approved :: Apache Software License",
          'Programming Language :: Python :: 3',
          'Programming Language :: Python :: 3.6',
      ],
      entry_points={
          'console_scripts': [
              'git-cloner=git_cloner.boot.boot:main',
          ],
      },)
