"""{"--force": False,
 "--help": False,
 "--host": None,
 "--in": None,
 "--org": "sstt",
 "--out": None,
 "--priv-token": None,
 "--retry": None,
 "--save": None,
 "--ssh": True,
 "--type": "github",
 "--user": None,
 "--verbose": False,
 "--version": False,
 "clon": True,
 "make-repos": False}"""
import runpy
import sys
import unittest

from pkg_resources import resource_filename

from git_cloner.boot import boot
from git_cloner.utils.utils import read
from tests.git_cloner.utils.utils import *

test_dir = "/tmp/test_tmp"

secrets_path = os.path.join(resource_filename('tests', 'resources'), 'secrets')


class BootAT(unittest.TestCase):
    def setUp(self):
        self.old_dir = set_test_dir(test_dir)
        self.args = sys.argv

    def tearDown(self):
        sys.argv = self.args
        restore_path(self.old_dir)

    def test_run_clone_at(self):
        print("Command")
        print("git-cloner clon -u user -p pass -U yunxao --ssh -t github -o /tmp/test_tmp/fhuertas "
              "-s /tmp/test_tmp/log.log")
        user = read(os.path.join(secrets_path, 'user'))
        password = read(os.path.join(secrets_path, 'password'))
        cmd = "git-cloner clon -u {user} -p {password} -U yunxao --ssh -t github -o {out_dir}/fhuertas " \
              "-s {out_dir}/log.log".format(out_dir=test_dir, user=user, password=password)
        print(cmd)
        sys.argv = cmd.split(" ")
        runpy.run_module(boot.__name__, run_name="__main__", alter_sys=False)
        with open(os.path.join(test_dir, "log.log")) as file:
            lines = len([line for line in file.readlines() if line.strip() != ""])
            self.assertEqual(lines, 10)

    def test_run_clone_from_gitlab_at(self):
        test_group = read(os.path.join(secrets_path, 'personal_group_test'))
        host = read(os.path.join(secrets_path, 'gitlab_host'))
        ssh_port = read(os.path.join(secrets_path, 'gitlab_port'))
        token = os.path.join(secrets_path, 'token_gitlab_personal')
        cmd = "git-cloner clon --priv-token={token} --org={test_group} --ssh {port} " \
              "-t gitlab -o {out_dir}/fhuertas -s {out_dir}/log.log -H {host}" \
            .format(token=token,
                    port=ssh_port,
                    test_group=test_group,
                    out_dir=test_dir,
                    host=host)

        print(cmd)
        sys.argv = cmd.split(" ")
        runpy.run_module(boot.__name__, run_name="__main__", alter_sys=False)
        with open(os.path.join(test_dir, "log.log")) as file:
            lines = len([line for line in file.readlines() if line.strip() != ""])
            self.assertEqual(lines, 1)
