import unittest

from pkg_resources import *

from git_cloner.model.owner.github_owner import GithubOwner
from git_cloner.utils.utils import *

secrets_path = os.path.join(resource_filename('tests', 'resources'), 'secrets')


# class GithubOwnerTest(unittest.TestCase):
class GithubOwnerIT(unittest.TestCase):
    def test_get_all_repos_it(self):
        config = Config.load_config({})
        config.user = read(secrets_path + '/user')
        config.password = read(secrets_path + '/password')
        repo = read(secrets_path + '/repo')
        expected_repo = "{}/{}".format(config.user, repo)

        results = GithubOwner(config.user, True).get_repos()
        full_names = [repo for repo in results if repo.raw_data.get('full_name') == expected_repo]
        self.assertEqual(len(full_names), 1)
