import unittest

from git_cloner.model.remotes.github_remote import GithubRemote


class GithubRemoteTest(unittest.TestCase):
    def test_build_from_url_ssh(self):
        remote = GithubRemote.build_from_url("git@github.com:owner/repo-name.git")
        self.assertTrue(remote.ssh)
        self.assertEqual(remote.owner, "owner")
        self.assertEqual(remote.repo_name, "repo-name")

    def test_build_from_url_https(self):
        remote = GithubRemote.build_from_url("https://github.com/owner/repo-name.git")
        self.assertFalse(remote.ssh)
        self.assertEqual(remote.owner, "owner")
        self.assertEqual(remote.repo_name, "repo-name")

    def test_build_remote_url_ssh(self):
        remote = GithubRemote("owner", "repo-name", True, "uuid")
        self.assertEqual(remote.build_remote_url(), "git@github.com:owner/repo-name.git")

    def test_build_remote_url_https(self):
        remote = GithubRemote("owner", "repo-name", False, "uuid")
        self.assertEqual(remote.build_remote_url(), "https://github.com/owner/repo-name.git")
