import unittest

from git_cloner.model.remotes.gitlab_remote import GitlabRemote


class TestGitlabRemote(unittest.TestCase):
    def test_build_remote_ssh(self):
        remote = GitlabRemote("http://git.host.com:2342", "owner", "repo", True)
        remote.build_remote_url()
        self.assertEqual(remote.build_remote_url(), "ssh://git@git.host.com:2342/owner/repo")

    def test_build_remote_http(self):
        remote = GitlabRemote("http://git.host.com:2342", "owner", "repo", False)
        remote.build_remote_url()
        self.assertEqual(remote.build_remote_url(), "http://git.host.com:2342/owner/repo")

    def test_build_remote_https(self):
        remote = GitlabRemote("https://git.host.com:2342", "owner", "repo", False)
        remote.build_remote_url()
        self.assertEqual(remote.build_remote_url(), "https://git.host.com:2342/owner/repo")
