import unittest

from git_cloner.model.remotes.github_remote import GithubRemote
from git_cloner.model.remotes.gitlab_remote import GitlabRemote
from tests.git_cloner.utils import gen_utils


class TestRemote(unittest.TestCase):
    def test_clone_cmd(self):
        remote = GithubRemote("owner", "repo-name", False, "uuid")
        self.assertEqual(remote.build_clone_cmd(), "git clone https://github.com/owner/repo-name.git {path}")

    def test_build_remote_add(self):
        remote = GitlabRemote("http://git.host.com:2342", "owner", "repo", True, 1111, "uuid")
        self.assertEqual(remote.build_remote_add(), "git remote add uuid ssh://git@git.host.com:1111/owner/repo")

    def test_build_remote_add_with_path(self):
        remote = GitlabRemote("http://git.host.com:2342/this/123", "owner", "repo", True, 1111, "uuid")
        self.assertEqual(remote.build_remote_add(), "git remote add uuid ssh://git@git.host.com:1111/this/123/owner/repo")

    def test_build_remote_remove(self):
        remote = GitlabRemote("git.host.com:2342", "owner", "repo", True, name="uuid")
        self.assertEqual(remote.build_remote_delete(), "git remote remove uuid")
