import unittest

from git_cloner.model.remotes.github_remote import GithubRemote
from git_cloner.model.remotes.gitlab_remote import GitlabRemote
from git_cloner.utils import logger
from git_cloner.utils.config import Config


class LoggerTest(unittest.TestCase):
    def test_build_remote_from_log_line_github(self):
        line = "Server: github, Repo: fhuertasorgfortest/monkey, Operation: clone, Result: False"
        Config.load_config({}).ssh = True
        remote = logger.build_remote_from_log_line(line)
        self.assertTrue(isinstance(remote, GithubRemote))
        self.assertEqual(remote.owner, "fhuertasorgfortest")
        self.assertEqual(remote.repo_name, "monkey")
        self.assertEqual(remote.ssh, True)


    def test_build_remote_from_log_line_gitlab(self):
        line = "Server: gitlab, Repo: fhuertasorgfortest/monkey, Operation: clone, Result: False"
        config = Config.load_config({})
        config.ssh = False
        config.host = "https://this.is.a/host"
        remote = logger.build_remote_from_log_line(line)
        self.assertTrue(isinstance(remote, GitlabRemote))
        self.assertEqual(remote.owner, "fhuertasorgfortest")
        self.assertEqual(remote.repo_name, "monkey")
        self.assertEqual(remote.is_ssh, False)
        self.assertEqual(remote.host,"https://this.is.a/host")
